""" The pdelab specific parts of the code generation process """

# Define the generators that are used throughout all pdelab specific code generations.
from dune.perftool.generation import generator_factory
dune_symbol = generator_factory(item_name="dune_symbol")
dune_preamble = generator_factory(item_name="dune_preamble", counted=True)
dune_include = generator_factory(on_store=lambda i: "#include<{}>".format(i), item_name="dune_include", no_deco=True)

from dune.perftool.transformer import quadrature_iname
from loopy import CInstruction

def quadrature_preamble(assignees=[]):
    return generator_factory(counted=True, item_name="quadrature_preamble", on_store=lambda code: CInstruction(quadrature_iname(), code, assignees=assignees))


# Now define some commonly used generators that do not fall into a specific category
@dune_symbol
def name_index(index):
    return str(index._indices[0])
